CLASS Acme.BEExternalOrder INHERITS Acme.BEOrder FINAL:

    CONSTRUCTOR PUBLIC BEExternalOrder (INPUT iOrderNum AS INTEGER, 
                                        OUTPUT lSuccess AS LOGICAL):
                                        
        SUPER (INPUT iOrderNum, OUTPUT lSuccess).
        
    END CONSTRUCTOR. /*  end constructor BEOrder */

    /* This method overrides the default processOrder which is contained in the 
    ** super class Acme.BEOrder.  This routine needs to invoke the functionality
    ** that is contained in Acme.DAOrder which knows how to process an external 
    ** order (sendInvoiceInfo).  However this class only has access to the protected
    ** data member rDataObject, which is of type Acme.IDataAccess.  Therefore via this
    ** object reference, this class can only invoke the methods which are defined 
    ** by the interface.  Therefore this class casts rDataObject to a Acme.DAOrder. 
    ** It can then has access to the sendInvoiceInfo method.
    */
    
    METHOD PUBLIC OVERRIDE VOID processOrder(OUTPUT lProcessed AS LOGICAL):
    
        DEFINE VARIABLE iInvoiceNum AS INTEGER INITIAL 12 NO-UNDO.
        
        CAST (rDataObject, Acme.DAOrder):sendInvoiceInfo (INPUT iInvoiceNum).
        ASSIGN lProcessed = TRUE. 
        
    END METHOD. /* end method processOrder */

    
END CLASS. /*end class Acme.BEExternalOrder */
