CLASS Acme.BEOrder INHERITS Acme.BusinessEntity:

       CONSTRUCTOR PUBLIC BEOrder (INPUT iOrderNum AS INTEGER, OUTPUT lSuccess AS LOGICAL):
       
         DEFINE VARIABLE cErrorString AS CHARACTER.
         
         rDataObject = NEW Acme.DAOrder (INPUT iOrderNum) NO-ERROR.
         
         /* If the instantiation of Acme.DAOrder fails, terminate the 
         ** instantiation of this object! 
         */
         IF NOT VALID-OBJECT (rDataObject)
            THEN DO:
                lSuccess = FALSE.
                IF ERROR-STATUS:NUM-MESSAGES GT 0 THEN
                    cErrorString = ERROR-STATUS:GET-MESSAGE (1).
                MESSAGE "No order available for orderNum " iOrderNum SKIP
                        cErrorString
                        VIEW-AS ALERT-BOX.
                DELETE OBJECT THIS-OBJECT.
             END. 
             ELSE
                lSuccess = TRUE. 
                
       END CONSTRUCTOR. /*  end constructor BEOrder */



       DESTRUCTOR PUBLIC  BEOrder ():
       
         IF VALID-OBJECT (rDataObject) THEN DO:
            DELETE OBJECT rDataObject.
            rDataObject = ?. /* prevents accidental use later */
         END.
         
       END DESTRUCTOR. /* end destructor BEOrder */



       METHOD PUBLIC VOID  processOrder (OUTPUT lProcessed AS LOGICAL):
       
         /* placeholder for polymorphism of process both internal and external orders */
         MESSAGE "Why is this order Free?" VIEW-AS ALERT-BOX INFO BUTTONS OK.
         ASSIGN lProcessed = NO.
         
       END METHOD. /* end method processOrder*/

END CLASS. /* end class Acme.BEOrder */
