&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          temp-db          PROGRESS
*/
&Scoped-define WINDOW-NAME cdsOrderWin

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _TEMP-TABLE 
/* ***********Included Temp-Table & Buffer definitions **************** */
{ProDataSet/ttItem.i}
{ProDataSet/dsOrderTT.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS cdsOrderWin 
/*------------------------------------------------------------------------

  File: dsOrderWinUpd.w

  Description: Demonstration file from 10.1A OOABL Extensions

 Input Parameters:
      <none>

  Output Parameters:
      <none>

 Author: These files are a subset of files produced by the Product Readiness
 team @ Progress Software
          
 GENERAL DISCLAIMER- This application was designed to demonstrate new syntax
 and concepts made available in the 10.1A product release. The goal of the 
 application is NOT to be a model application but rather as an example of how 
 to use object oriented syntax in the ABL.
 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Original Application Local Variable Definitions ---                                       */
/* Stores Character value of the Status of the Save operations */
DEFINE VARIABLE cStatus AS CHARACTER   NO-UNDO.
/* stores return value for success of function calls */
DEFINE VARIABLE ret AS LOGICAL     NO-UNDO.
/********** XML/TO FROM Path Variables ********/
DEFINE VARIABLE cPath AS CHARACTER   NO-UNDO INITIAL "c:\OpenEdge\WRK\Workspace\101ATraining\".
DEFINE VARIABLE cOutputFile AS CHARACTER  NO-UNDO.

DEFINE VARIABLE hSAXReader AS HANDLE NO-UNDO.
DEFINE VARIABLE hBuf AS HANDLE NO-UNDO.
DEFINE VARIABLE hDBFld AS HANDLE NO-UNDO.
DEFINE VARIABLE cErrorMessage AS CHARACTER   NO-UNDO.
/* Accumulate all the text data for one element coming in through potentially */
/* multiple calls (per element) to the Characters procedure */
DEFINE VARIABLE currentFieldValue AS CHARACTER   NO-UNDO.
/* used to branch logic in StartElement,EndElement, and Character callbacks for SAX-Reader */
DEFINE VARIABLE iProcessingState AS INTEGER  NO-UNDO.

DEFINE VARIABLE lProcessed AS LOGICAL NO-UNDO.
DEFINE VARIABLE hDSOrder AS HANDLE NO-UNDO.
DEFINE VARIABLE httItem AS HANDLE NO-UNDO.

/* Dataset filled from OO4GL Code */
{ProDataSet/dsOrder.i}

/* Demonstration of the CALLBACK-PROCEDURE Debugging message. */
&Global-define debugmode YES

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME dsFrame
&Scoped-define BROWSE-NAME brItem

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES ttItem ttOline

/* Definitions for BROWSE brItem                                        */
&Scoped-define FIELDS-IN-QUERY-brItem ttItem.Itemnum ttItem.ItemName ~
ttItem.Onhand ttItem.Price ttItem.OnOrder ttItem.ReOrder 
&Scoped-define ENABLED-FIELDS-IN-QUERY-brItem 
&Scoped-define QUERY-STRING-brItem FOR EACH ttItem NO-LOCK INDEXED-REPOSITION
&Scoped-define OPEN-QUERY-brItem OPEN QUERY brItem FOR EACH ttItem NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-brItem ttItem
&Scoped-define FIRST-TABLE-IN-QUERY-brItem ttItem


/* Definitions for BROWSE OlineBrowse                                   */
&Scoped-define FIELDS-IN-QUERY-OlineBrowse ttOline.Ordernum ttOline.Linenum ~
ttOline.Itemnum ttOline.Price ttOline.Qty ttOline.Discount ~
ttOline.ExtendedPrice ttOline.OrderLineStatus 
&Scoped-define ENABLED-FIELDS-IN-QUERY-OlineBrowse ttOline.Qty ~
ttOline.Discount 
&Scoped-define ENABLED-TABLES-IN-QUERY-OlineBrowse ttOline
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-OlineBrowse ttOline
&Scoped-define QUERY-STRING-OlineBrowse FOR EACH ttOline NO-LOCK INDEXED-REPOSITION
&Scoped-define OPEN-QUERY-OlineBrowse OPEN QUERY OlineBrowse FOR EACH ttOline NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-OlineBrowse ttOline
&Scoped-define FIRST-TABLE-IN-QUERY-OlineBrowse ttOline


/* Definitions for FRAME dsFrame                                        */
&Scoped-define OPEN-BROWSERS-IN-QUERY-dsFrame ~
    ~{&OPEN-QUERY-brItem}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS btnProcessOrder iOrderNum cRepName ~
tInternalOrder iCustNum cCustname OlineBrowse brItem BtnDone dOrderTotal 
&Scoped-Define DISPLAYED-OBJECTS iOrderNum cRepName tInternalOrder iCustNum ~
cCustname dOrderTotal 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR cdsOrderWin AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_File 
       MENU-ITEM m_Exit         LABEL "Exit"          .

DEFINE MENU MENU-BAR-dsOrderWin MENUBAR
       SUB-MENU  m_File         LABEL "File"          .


/* Definitions of the field level widgets                               */
DEFINE BUTTON btnAdd 
     LABEL "Add" 
     SIZE 13.8 BY 1.14.

DEFINE BUTTON BtnCancel 
     LABEL "Cancel" 
     SIZE 14 BY 1.14.

DEFINE BUTTON btnDelete 
     LABEL "Delete" 
     SIZE 13.8 BY 1.14.

DEFINE BUTTON BtnDone DEFAULT 
     LABEL "&Done" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON btnProcessOrder 
     LABEL "Process Order" 
     SIZE 17 BY 1.14.

DEFINE BUTTON BtnSave 
     LABEL "Save" 
     SIZE 13.8 BY 1.14.

DEFINE VARIABLE cCustname AS CHARACTER FORMAT "X(256)":U INITIAL ? 
     LABEL "Cust Name" 
     VIEW-AS FILL-IN 
     SIZE 46 BY 1 NO-UNDO.

DEFINE VARIABLE cRepName AS CHARACTER FORMAT "X(256)":U INITIAL ? 
     LABEL "Sales Rep" 
     VIEW-AS FILL-IN 
     SIZE 31 BY 1 NO-UNDO.

DEFINE VARIABLE dOrderTotal AS DECIMAL FORMAT "->>,>>9.99":U INITIAL 0 
     LABEL "Order Total" 
     VIEW-AS FILL-IN 
     SIZE 15.8 BY 1 NO-UNDO.

DEFINE VARIABLE iCustNum AS INTEGER FORMAT ">>>>9":U INITIAL 0 
     LABEL "Cust Num" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE iOrderNum AS INTEGER FORMAT ">>>>9":U INITIAL 0 
     LABEL "Order Num" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE tInternalOrder AS LOGICAL INITIAL no 
     LABEL "Internal Order" 
     VIEW-AS TOGGLE-BOX
     SIZE 18 BY .81 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY brItem FOR 
      ttItem SCROLLING.

DEFINE QUERY OlineBrowse FOR 
      ttOline SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE brItem
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS brItem cdsOrderWin _STRUCTURED
  QUERY brItem NO-LOCK DISPLAY
      ttItem.Itemnum FORMAT "zzzzzzzzz9":U
      ttItem.ItemName FORMAT "x(25)":U
      ttItem.Onhand FORMAT "->>>>9":U
      ttItem.Price FORMAT "->,>>>,>>9.99":U
      ttItem.OnOrder FORMAT "->>>>9":U
      ttItem.ReOrder FORMAT "->>>>9":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 55 BY 6.43 FIT-LAST-COLUMN.

DEFINE BROWSE OlineBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS OlineBrowse cdsOrderWin _STRUCTURED
  QUERY OlineBrowse NO-LOCK DISPLAY
      ttOline.Ordernum FORMAT "zzzzzzzzz9":U
      ttOline.Linenum FORMAT ">>9":U
      ttOline.Itemnum FORMAT "zzzzzzzzz9":U WIDTH 10.6
      ttOline.Price FORMAT "->,>>>,>>9.99":U WIDTH 10
      ttOline.Qty FORMAT "->>>>9":U
      ttOline.Discount FORMAT ">>9%":U
      ttOline.ExtendedPrice FORMAT "->>>,>>9.99":U WIDTH 22.4
      ttOline.OrderLineStatus FORMAT "x(20)":U
  ENABLE
      ttOline.Qty
      ttOline.Discount
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 104 BY 6.43 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME dsFrame
     btnProcessOrder AT ROW 1.1 COL 98 WIDGET-ID 6
     iOrderNum AT ROW 1.24 COL 12 COLON-ALIGNED
     cRepName AT ROW 1.24 COL 39.2 COLON-ALIGNED
     tInternalOrder AT ROW 1.24 COL 77 WIDGET-ID 4
     iCustNum AT ROW 2.43 COL 12 COLON-ALIGNED
     cCustname AT ROW 2.43 COL 39 COLON-ALIGNED
     OlineBrowse AT ROW 3.86 COL 3
     brItem AT ROW 3.86 COL 108 WIDGET-ID 100
     BtnDone AT ROW 10.52 COL 148
     btnAdd AT ROW 10.57 COL 2.8
     btnDelete AT ROW 10.57 COL 17.6
     BtnSave AT ROW 10.57 COL 32.6
     BtnCancel AT ROW 10.57 COL 47.8
     dOrderTotal AT ROW 10.57 COL 105.8 RIGHT-ALIGNED
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1.19
         SIZE 164.2 BY 11.1
         DEFAULT-BUTTON BtnDone.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
   Temp-Tables and Buffers:
      TABLE: ttItem T "?" NO-UNDO TEMP-DB ttItem
      TABLE: ttOline T "?" NO-UNDO TEMP-DB ttOline
      TABLE: ttOrder T "?" NO-UNDO TEMP-DB ttOrder
   END-TABLES.
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW cdsOrderWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Order Update"
         HEIGHT             = 11.29
         WIDTH              = 164.4
         MAX-HEIGHT         = 44.95
         MAX-WIDTH          = 256
         VIRTUAL-HEIGHT     = 44.95
         VIRTUAL-WIDTH      = 256
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-dsOrderWin:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW cdsOrderWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME dsFrame
   FRAME-NAME                                                           */
/* BROWSE-TAB OlineBrowse cCustname dsFrame */
/* BROWSE-TAB brItem OlineBrowse dsFrame */
/* SETTINGS FOR BUTTON btnAdd IN FRAME dsFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON BtnCancel IN FRAME dsFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON btnDelete IN FRAME dsFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR BUTTON BtnSave IN FRAME dsFrame
   NO-ENABLE                                                            */
ASSIGN 
       cCustname:READ-ONLY IN FRAME dsFrame        = TRUE.

ASSIGN 
       cRepName:READ-ONLY IN FRAME dsFrame        = TRUE.

/* SETTINGS FOR FILL-IN dOrderTotal IN FRAME dsFrame
   ALIGN-R                                                              */
ASSIGN 
       dOrderTotal:READ-ONLY IN FRAME dsFrame        = TRUE.

ASSIGN 
       iCustNum:READ-ONLY IN FRAME dsFrame        = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(cdsOrderWin)
THEN cdsOrderWin:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE brItem
/* Query rebuild information for BROWSE brItem
     _TblList          = "Temp-Tables.ttItem"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _FldNameList[1]   = Temp-Tables.ttItem.Itemnum
     _FldNameList[2]   = Temp-Tables.ttItem.ItemName
     _FldNameList[3]   = Temp-Tables.ttItem.Onhand
     _FldNameList[4]   = Temp-Tables.ttItem.Price
     _FldNameList[5]   = Temp-Tables.ttItem.OnOrder
     _FldNameList[6]   = Temp-Tables.ttItem.ReOrder
     _Query            is OPENED
*/  /* BROWSE brItem */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE OlineBrowse
/* Query rebuild information for BROWSE OlineBrowse
     _TblList          = "Temp-Tables.ttOline"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _FldNameList[1]   = Temp-Tables.ttOline.Ordernum
     _FldNameList[2]   = Temp-Tables.ttOline.Linenum
     _FldNameList[3]   > Temp-Tables.ttOline.Itemnum
"ttOline.Itemnum" ? ? "integer" ? ? ? ? ? ? no ? no no "10.6" yes no no "U" "" ""
     _FldNameList[4]   > Temp-Tables.ttOline.Price
"ttOline.Price" ? ? "decimal" ? ? ? ? ? ? no ? no no "10" yes no no "U" "" ""
     _FldNameList[5]   > Temp-Tables.ttOline.Qty
"ttOline.Qty" ? ? "integer" ? ? ? ? ? ? yes ? no no ? yes no no "U" "" ""
     _FldNameList[6]   > Temp-Tables.ttOline.Discount
"ttOline.Discount" ? ? "integer" ? ? ? ? ? ? yes ? no no ? yes no no "U" "" ""
     _FldNameList[7]   > Temp-Tables.ttOline.ExtendedPrice
"ttOline.ExtendedPrice" ? ? "decimal" ? ? ? ? ? ? no ? no no "22.4" yes no no "U" "" ""
     _FldNameList[8]   = Temp-Tables.ttOline.OrderLineStatus
     _Query            is NOT OPENED
*/  /* BROWSE OlineBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME cdsOrderWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL cdsOrderWin cdsOrderWin
ON END-ERROR OF cdsOrderWin /* Order Update */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL cdsOrderWin cdsOrderWin
ON WINDOW-CLOSE OF cdsOrderWin /* Order Update */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME brItem
&Scoped-define SELF-NAME brItem
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL brItem cdsOrderWin
ON MOUSE-SELECT-DBLCLICK OF brItem IN FRAME dsFrame
DO:
  
  /* sets the oline item to the dblclicked item browse item */
  IF AVAILABLE ttOline 
      THEN ASSIGN ttOline.itemnum:SCREEN-VALUE IN BROWSE OlineBrowse  
      = STRING(ttItem.itemnum).

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnAdd
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnAdd cdsOrderWin
ON CHOOSE OF btnAdd IN FRAME dsFrame /* Add */
DO:
/* sets iLastLine to generate line numbers until actual save */ 
DEFINE VARIABLE iLastLine AS INTEGER NO-UNDO.
DEFINE VARIABLE riOline AS ROWID.

/* Get last line number to increment new line UI, ELSE set to 0 */
FIND LAST ttOLine NO-LOCK NO-ERROR.
IF AVAILABLE ttOline THEN iLastLine = ttOline.LineNum.
    ELSE ASSIGN iLastLine = 0.

DO WITH FRAME  {&FRAME-NAME}:
  /* Create the ttOline */ 
  CREATE ttOline.
  /* Initialize so the synchronize finds a matching item. */
  ASSIGN 
      ttOline.Ordernum = ttOrder.ordernum
      ttOline.linenum = iLastLine + 1
      ttOline.Itemnum = ttItem.itemnum
      ttOline.price = ttItem.Price
      ttOline.qty = 1.

   /* Store ROWID for refreshing the browse */
   /* Recommended Separate ASSIGN because ROWID only has value after indexing */
   ASSIGN riOline = ROWID(ttOline).


  /* Sensitize buttons to save or cancel changes */
  ASSIGN
      BtnSave:SENSITIVE = TRUE
      BtnCancel:SENSITIVE = TRUE.

  /* Calculate new orderline and Order Total values */
   RUN UICalcOLine.
   RUN UICalcOrderTotal.

  /* SYNCHRONIZE dataset order buffer to rebuild all related details 
    and redisplay in browse objects */
  DATASET dsOrder:GET-BUFFER-HANDLE(1):SYNCHRONIZE().
  
  /* Code to reposition to newly created row after the synch */
  BROWSE OlineBrowse:QUERY:REPOSITION-TO-ROWID(riOline).

END. /* WITH FRAME */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnCancel
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnCancel cdsOrderWin
ON CHOOSE OF BtnCancel IN FRAME dsFrame /* Cancel */
DO:
 
  DEFINE VARIABLE hdsOrder   AS HANDLE     NO-UNDO.
  DEFINE VARIABLE lANS     AS LOGICAL    NO-UNDO.

 
  MESSAGE "Are you sure you want to reject all changes since your last save?" 
      VIEW-AS ALERT-BOX BUTTONS YES-NO UPDATE lAns.
  IF lAns THEN
      DO WITH FRAME  {&FRAME-NAME}:
          hdsOrder = DATASET dsOrder:HANDLE.
          hdsOrder:REJECT-CHANGES(). 
/*           RUN RejectByRow. */
         
          ASSIGN btnSave:SENSITIVE = FALSE
                 btnCancel:SENSITIVE = FALSE
                 btnDelete:SENSITIVE = TRUE
                 iOrderNum:SENSITIVE = TRUE.
          RUN UICalcOrderTotal.
          DATASET dsOrder:GET-BUFFER-HANDLE(1):SYNCHRONIZE().
      END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnDelete
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnDelete cdsOrderWin
ON CHOOSE OF btnDelete IN FRAME dsFrame /* Delete */
DO:
/* Variable to prevent accidental deletions */
DEF VAR lAns AS LOGICAL INITIAL NO NO-UNDO.
DEF VAR riOline AS ROWID NO-UNDO.

DO WITH FRAME  {&FRAME-NAME}:
    MESSAGE "Are you sure you want to delete line " ttOline.linenum "?" 
      VIEW-AS ALERT-BOX BUTTONS YES-NO UPDATE lAns.
  IF lAns THEN
        DO:
         DELETE ttOline.
         BtnSave:SENSITIVE = TRUE.
         BtnCancel:SENSITIVE = TRUE.
         FIND LAST ttOline NO-LOCK NO-ERROR.
         IF AVAILABLE ttOline THEN
            ASSIGN riOline = ROWID(ttOline).
           ELSE
           DO:
                riOline = ?.
                btnDelete:SENSITIVE = FALSE.
           END.
              
         END.       
        ELSE
         ASSIGN riOline = ROWID(ttOline).
END. /* DO END */
    /* recalculate the OrderTotal to keep UI current */ 
    RUN UICalcOrderTotal.

    /* clears the browse of the delete Oline */
    DATASET dsOrder:GET-BUFFER-HANDLE(1):SYNCHRONIZE().
    /* Code to reposition to newly created row after the synch */
    IF riOline NE ? THEN
      BROWSE OlineBrowse:QUERY:REPOSITION-TO-ROWID(riOline).

END. /* Trigger END */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnDone
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnDone cdsOrderWin
ON CHOOSE OF BtnDone IN FRAME dsFrame /* Done */
DO:
      APPLY "CLOSE":U TO THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnProcessOrder
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnProcessOrder cdsOrderWin
ON CHOOSE OF btnProcessOrder IN FRAME dsFrame /* Process Order */
DO:
    RUN OrdersWindow/processOrderMain.p (INPUT tInternalOrder, 
                                         INPUT iOrderNum, 
                                         OUTPUT lProcessed).

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnSave
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnSave cdsOrderWin
ON CHOOSE OF BtnSave IN FRAME dsFrame /* Save */
DO:
  DEFINE VARIABLE hdsChanges AS HANDLE     NO-UNDO.
  DEFINE VARIABLE hdsOrder   AS HANDLE     NO-UNDO.
  DEFINE VARIABLE hQuery   AS HANDLE     NO-UNDO.
  DEFINE VARIABLE hBuffer  AS HANDLE     NO-UNDO.

  hdsOrder = DATASET dsOrder:HANDLE.
  CREATE DATASET hdsChanges.
  hdsChanges:CREATE-LIKE(hdsOrder).
  hdsChanges:GET-CHANGES(hdsOrder).
  TEMP-TABLE ttOline:TRACKING-CHANGES = FALSE.

  RUN Acme/updateOrder.p 
              (INPUT-OUTPUT DATASET-HANDLE hdsChanges BY-REFERENCE).
  
   /* Iniitialize local error status variable */
   ASSIGN cStatus = "".

   /* Check the ERROR status that may have been returned. */
   IF hdsChanges:ERROR THEN
   DO WITH FRAME {&FRAME-NAME}:
       /* There was an error somewhere in the updates. Find it. */
       CREATE QUERY hQuery.
       hBuffer = hdsChanges:GET-BUFFER-HANDLE(2).
       hQuery:ADD-BUFFER(hBuffer).
       hQuery:QUERY-PREPARE("FOR EACH " + hBuffer:NAME).
       hQuery:QUERY-OPEN().
       hQuery:GET-FIRST().
       DO WHILE NOT hQuery:QUERY-OFF-END:
           IF hBuffer:ERROR THEN
               cStatus = cStatus + hBuffer:ERROR-STRING + CHR(10).
           hQuery:GET-NEXT().
       END.
       hQuery:QUERY-CLOSE().
       DELETE  OBJECT hQuery.
       MESSAGE "Error Messages "cStatus VIEW-AS ALERT-BOX.
        /* RUN OrderMain.p (INPUT iOrderNum, OUTPUT DATASET dsOrder). */
       DELETE OBJECT hdsChanges NO-ERROR.
       APPLY "LEAVE" TO iorderNum IN FRAME {&FRAME-NAME}.
       ASSIGN iOrderNum:SENSITIVE = TRUE.
   END.
   /* END of Error status checking. */ 

   ELSE
   DO WITH FRAME {&FRAME-NAME} : 
       hdsChanges:MERGE-CHANGES(hdsOrder). 
       /* This forces the relation queries to re-open and refresh the browse. Doing
       {&OPEN-QUERY-OlineBrowse} does not work because the browse query is the
       relation query, not the base ttOline query. */
      BUFFER TTOrder:SYNCHRONIZE().
    
      TEMP-TABLE ttOline:TRACKING-CHANGES = TRUE.
    
      /* Re-enable the Order Number to select another Order. */
      ASSIGN iOrderNum:SENSITIVE = TRUE
          SELF:SENSITIVE = FALSE
          btnCancel:SENSITIVE = FALSE.
     END.
   DELETE OBJECT hdsChanges NO-ERROR.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME cRepName
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL cRepName cdsOrderWin
ON HELP OF cRepName IN FRAME dsFrame /* Sales Rep */
DO:
 DEF VARIABLE cTempRepName AS CHAR.

  DO WITH FRAME   {&FRAME-NAME}:
    ASSIGN cTempRepname = cRepName.
    RUN Acme/dsDynSingleDlg.w (INPUT FALSE, OUTPUT cTempRepName).
    IF cTempRepName <> cRepName AND cTempRepName <> "" THEN
    DO WITH FRAME {&FRAME-NAME}:
      ASSIGN cRepName = cTempRepName.
      DISPLAY cRepName.
      /* Disable the Order Number until changes are saved. */
      iOrderNum:SENSITIVE = FALSE.
      BtnSave:SENSITIVE = TRUE.
      BtnCancel:SENSITIVE = TRUE.
    END.
  
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME iOrderNum
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL iOrderNum cdsOrderWin
ON HELP OF iOrderNum IN FRAME dsFrame /* Order Num */
DO:
    DO WITH FRAME   {&FRAME-NAME}:
    RUN Acme/dsDynCustOrdDlg.w (INPUT FALSE, OUTPUT iOrderNum).
    DISPLAY iOrderNum.
    APPLY "LEAVE" TO iOrderNum.
    RETURN NO-APPLY.
   END.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL iOrderNum cdsOrderWin
ON LEAVE OF iOrderNum IN FRAME dsFrame /* Order Num */
DO:
  ASSIGN iOrderNum.
  IF iOrderNum NE 0 THEN 
  DO:
      RUN PurgeDataset.
      RUN Acme/OrderMain.p (INPUT iOrderNum, OUTPUT DATASET dsOrder BY-REFERENCE).
      RUN DisplayDataSetDetails.

      
  END.       /* END DO IF iOrderNum NE 0 */
END.         /* END trigger */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Exit
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Exit cdsOrderWin
ON CHOOSE OF MENU-ITEM m_Exit /* Exit */
DO:
  APPLY "Close":U TO THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME OlineBrowse
&Scoped-define SELF-NAME OlineBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL OlineBrowse cdsOrderWin
ON ROW-LEAVE OF OlineBrowse IN FRAME dsFrame
DO:
  DEFINE VARIABLE hCol AS HANDLE     NO-UNDO.
  /* check for changes */
  IF OlineBrowse:MODIFIED THEN
  DO:
     /* saves the input to ttOline */
     ASSIGN INPUT BROWSE OlineBrowse 
                 {&ENABLED-FIELDS-IN-QUERY-OlineBrowse}
             /* Disable the Order Number until changes are saved. */
             iOrderNum:SENSITIVE IN FRAME dsFrame = FALSE
             BtnSave:SENSITIVE IN FRAME dsFrame = TRUE.
             BtnCancel:SENSITIVE IN FRAME dsFrame = TRUE.
    RUN UICalcOLine.
    RUN UICalcOrderTotal.
  END. /* Modified */    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL OlineBrowse cdsOrderWin
ON VALUE-CHANGED OF OlineBrowse IN FRAME dsFrame
DO:
  /* sets the modified to NO */
  OlineBrowse:MODIFIED = NO.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME tInternalOrder
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL tInternalOrder cdsOrderWin
ON VALUE-CHANGED OF tInternalOrder IN FRAME dsFrame /* Internal Order */
DO:
  ASSIGN tInternalOrder.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME brItem
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK cdsOrderWin 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
DO:
    /* stops waiting for messages from Sonic */
    APPLY "U1" TO THIS-PROCEDURE. 

    RUN disable_UI.

END.
   

/*  Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  ASSIGN iOrderNum = 0.

 /* using a temp table to get items */
  RUN ProDataSet/getItems.p (INPUT-OUTPUT TABLE ttItem).
  /* using APPEND If Remotes you'd need to comment in code below and Out Line above */
  /*   RUN ProDataSet/getItems.p (INPUT-OUTPUT TABLE ttItem APPEND).  */

  /* Storing dataset handle to use for messaging with Sonic to copy */
  hdsOrder = DATASET dsOrder:HANDLE. 
  httItem = TEMP-TABLE ttItem:HANDLE. 
  RUN enable_UI.
  /* In order to see the effect of the REPOSITION relation mode,
     replace the default AppBuilder-generated static queries with
     the ones that are part of the Data-Relations. */
  OlineBrowse:QUERY =
      DATASET dsOrder:GET-RELATION("OrderLine"):QUERY.

  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI cdsOrderWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(cdsOrderWin)
  THEN DELETE WIDGET cdsOrderWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DisplayDataSetDetails cdsOrderWin 
PROCEDURE DisplayDataSetDetails :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    TEMP-TABLE ttOline:TRACKING-CHANGES = TRUE.
    FIND FIRST ttOrder NO-ERROR.
    IF NOT AVAILABLE (ttOrder) THEN
        LEAVE.
    RUN UICalcOrderTotal.
    DO WITH FRAME dsFrame:
        ASSIGN iOrderNum:SCREEN-VALUE = STRING(ttOrder.OrderNum)
               iCustNum:SCREEN-VALUE  = STRING(ttOrder.CustNum)
               cCustName:SCREEN-VALUE = ttOrder.CustName
               cRepName:SCREEN-VALUE  = ttOrder.RepName
               dOrderTotal:SCREEN-VALUE = STRING(ttOrder.OrderTotal)
               BtnSave:SENSITIVE = FALSE.
               BtnAdd:SENSITIVE = TRUE.
               BtnDelete:SENSITIVE = TRUE.
               DATASET dsOrder:GET-BUFFER-HANDLE(1):SYNCHRONIZE().
               FIND ttItem WHERE ttItem.itemnum = ttOline.itemnum.
               REPOSITION brItem TO ROWID(ROWID(ttItem)).
               APPLY "VALUE-CHANGED":U  TO brItem.
    END.   /* END DO WITH FRAME */
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI cdsOrderWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY iOrderNum cRepName tInternalOrder iCustNum cCustname dOrderTotal 
      WITH FRAME dsFrame IN WINDOW cdsOrderWin.
  ENABLE btnProcessOrder iOrderNum cRepName tInternalOrder iCustNum cCustname 
         OlineBrowse brItem BtnDone dOrderTotal 
      WITH FRAME dsFrame IN WINDOW cdsOrderWin.
  {&OPEN-BROWSERS-IN-QUERY-dsFrame}
  VIEW cdsOrderWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE EndDocument cdsOrderWin 
PROCEDURE EndDocument :
/*------------------------------------------------------------------------------
  Purpose:     Set all handles back to unknown. 
  Parameters:  <none>
  Notes:   You could add any logic here when Read is done any dynamic object
  created in the process can be deleted.     
------------------------------------------------------------------------------*/

ASSIGN  hBuf = ?
        hDBFld = ?.
        currentFieldValue = "".

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Error cdsOrderWin 
PROCEDURE Error :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER errMessage  AS CHARACTER NO-UNDO.
/* RETURN ERROR in an error handler implicitly calls 
   SELF:STOP-PARSING(), sets SELF:PARSE-STATUS to 
   SAX-PARSER-ERROR, and raises the Progress ERROR 
   condition */
/* cErrorMessage = errMessage                       */
/* + "(Line " + STRING(SELF:LOCATOR-LINE-NUMBER)    */
/* + ", Col " + STRING(SELF:LOCATOR-COLUMN-NUMBER)  */
/* + ")".                                           */
RETURN ERROR errMessage
+ "(Line " + STRING(SELF:LOCATOR-LINE-NUMBER)
+ ", Col " + STRING(SELF:LOCATOR-COLUMN-NUMBER)
+ ")".

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PurgeDataset cdsOrderWin 
PROCEDURE PurgeDataset :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
      /* empty temp table to load from a message */
      TEMP-TABLE ttOline:TRACKING-CHANGES = FALSE.
      DATASET dsOrder:GET-RELATION(1):QUERY:QUERY-CLOSE().
      DATASET dsOrder:EMPTY-DATASET().
      {&OPEN-BROWSERS-IN-QUERY-{&FRAME-NAME}}
     /* Clears fillin values */
     DO WITH FRAME dsFrame:
                 ASSIGN iOrderNum:SCREEN-VALUE = ""
                        iCustNum:SCREEN-VALUE  = ""
                        cCustName:SCREEN-VALUE = ""
                        cRepName:SCREEN-VALUE  = ""
                        dOrderTotal:SCREEN-VALUE = "".
                        BtnSave:SENSITIVE = FALSE.
                        BtnAdd:SENSITIVE = FALSE.
                        BtnDelete:SENSITIVE = FALSE.
                       
     END.   /* END DO WITH FRAME */
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE RejectByRow cdsOrderWin 
PROCEDURE RejectByRow :
/*------------------------------------------------------------------------------
  Purpose:   This was needed to implement what is now available in the 
  REJECT-CHANGES. Left in as an example of how you could write your own 
  reject-row-changes code.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
FOR EACH ttOlineBefore BY  BUFFER ttOlineBefore:ROW-STATE DESCENDING:
        BUFFER  ttOlineBefore:REJECT-ROW-CHANGES().
END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rejectedMessageHandler cdsOrderWin 
PROCEDURE rejectedMessageHandler :
DEFINE INPUT PARAMETER hMessage AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER hMessageConsumer AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER hAutoReply AS HANDLE NO-UNDO. /* Not used in example */

DEFINE VARIABLE iNumParts AS INTEGER NO-UNDO.
DEFINE VARIABLE cContentType AS CHARACTER NO-UNDO.
DEFINE VARIABLE cErrorCode AS CHARACTER NO-UNDO.
DEFINE VARIABLE cExceptionCode AS CHARACTER NO-UNDO.
DEFINE VARIABLE cErrorText AS CHARACTER NO-UNDO.
DEFINE VARIABLE cMsgType AS CHARACTER NO-UNDO.
DEFINE VARIABLE hMessagePart AS HANDLE NO-UNDO.

MESSAGE "Reject message" VIEW-AS alert-box.

cErrorCode = DYNAMIC-FUNCTION("getCharProperty" IN hMessage, "errorCode").
cErrorText = DYNAMIC-FUNCTION("getCharProperty" IN hMessage, "errorText").
cExceptionCode = DYNAMIC-FUNCTION("getCharProperty" IN hMessage, "exception").

MESSAGE cErrorText VIEW-AS ALERT-BOX.
DISPLAY cErrorCode cExceptionCode.

iNumParts = DYNAMIC-FUNCTION("getPartCount" IN hMessage).

IF DYNAMIC-FUNCTION("isMessagePart" IN hMessage, 1) = TRUE THEN DO:
  cContentType = DYNAMIC-FUNCTION("getMessagePartByIndex":U IN hMessage,
                                 INPUT iNumParts,
                                 OUTPUT hMessagePart).
  cMsgType = DYNAMIC-FUNCTION('getMessageType':U IN hMessagePart).
  DISPLAY iNumParts cMsgType cContentType.
END.

RUN deleteMessage IN hMessage.


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE UICalcOLine cdsOrderWin 
PROCEDURE UICalcOLine :
/*------------------------------------------------------------------------------
  Purpose:   Calculated extended price by factoring in the discount  
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

DO WITH FRAME {&FRAME-NAME}:
    ASSIGN ttOline.ExtendedPrice = (ttOline.price * ttOline.qty) -
                ((ttOline.price * ttOline.qty) * (ttOline.discount / 100)).
END. /*WITH FRAME */   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE UICalcOrderTotal cdsOrderWin 
PROCEDURE UICalcOrderTotal :
/*------------------------------------------------------------------------------
  Purpose:  Generic calculation of order line total for ENTIRE order    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE VARIABLE iLineNum AS INTEGER INITIAL 0.
DEFINE VARIABLE riOline AS ROWID NO-UNDO.
  
     
DO WITH FRAME {&FRAME-NAME}:
    
    /* Stores current rowid for ttOline to reload after loop of all Olines */
    IF AVAILABLE ttOline THEN ASSIGN riOline = ROWID(ttOline).
    ASSIGN ttOrder.OrderTotal = 0.
   /* totals all orderlines using extended price */
    FOR EACH ttOline:
      ttOrder.OrderTotal = ttOrder.OrderTotal + ttOline.ExtendedPrice.
    END.
    /* displays the total */ 
    ASSIGN dOrderTotal = ttOrder.OrderTotal.
    DISPLAY dOrderTotal.

    /* required to load current Oline after calcOrderTotal. */
    IF riOline <> ? THEN
    FIND ttOline WHERE ROWID(ttOLine) = riOline.
   
END. /*WITH FRAME */   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

