/* dsOrderTT.i -- include file for Temp-Table definitions in dsOrder. */

DEFINE TEMP-TABLE ttOrder 
   FIELD Ordernum AS INTEGER LABEL "Order Num" FORMAT "zzzzzzzzz9" INITIAL "0"
   FIELD CustNum AS INTEGER LABEL "Cust Num" FORMAT ">>>>9" INITIAL "0"
   FIELD OrderDate AS DATE LABEL "Ordered" FORMAT "99/99/99" INITIAL "TODAY"
   FIELD ShipDate AS DATE LABEL "Shipped" FORMAT "99/99/9999"
   FIELD PromiseDate AS DATE LABEL "Promised" FORMAT "99/99/99"
   FIELD Carrier AS CHARACTER LABEL "Carrier" FORMAT "x(25)"
   FIELD Instructions AS CHARACTER LABEL "Instructions" FORMAT "x(50)"
   FIELD PO AS CHARACTER LABEL "PO" FORMAT "x(20)"
   FIELD Terms AS CHARACTER LABEL "Terms" FORMAT "x(20)" INITIAL "Net30"
   FIELD SalesRep AS CHARACTER LABEL "Sales Rep" FORMAT "x(4)"
   FIELD BillToID AS INTEGER LABEL "Bill To ID" FORMAT "zzzzzzzzz9" INITIAL "0"
   FIELD ShipToID AS INTEGER LABEL "Ship To ID" FORMAT "zzzzzzzzz9" INITIAL "0"
   FIELD OrderStatus AS CHARACTER LABEL "Order Status" FORMAT "x(20)" INITIAL "Ordered"
                        VIEW-AS COMBO-BOX
                        LIST-ITEMS "Ordered","Back Ordered", "Partially Shipped", "Shipped"
   
   FIELD WarehouseNum AS INTEGER LABEL "Warehouse Num" FORMAT "zzzzzzzzz9" INITIAL "0"
   FIELD Creditcard AS CHARACTER LABEL "Credit Card" FORMAT "x(20)" INITIAL "Visa"
            VIEW-AS COMBO-BOX
            LIST-ITEMS "Visa","American Express", "Master Card"
    FIELD OrderTotal AS DECIMAL 
    FIELD CustName AS CHARACTER FORMAT "x(30)"
    FIELD RepName  AS CHARACTER FORMAT "x(30)"
        INDEX OrderNum IS UNIQUE PRIMARY OrderNum
        INDEX CustOrder IS UNIQUE CustNum
            Ordernum
        INDEX OrderDate 
            OrderDate
        INDEX OrderStatus
            OrderStatus
        INDEX SalesRep
            SalesRep.

DEFINE TEMP-TABLE ttOline    
   BEFORE-TABLE ttOlineBefore
   FIELD Ordernum AS INTEGER LABEL "Order Num" FORMAT "zzzzzzzzz9" INITIAL "0"
   FIELD Linenum AS INTEGER LABEL "Line Num" FORMAT ">>9" INITIAL "0"
   FIELD Itemnum AS INTEGER LABEL "Item Num" FORMAT "zzzzzzzzz9" INITIAL "0"
   FIELD Price AS DECIMAL LABEL "Price" FORMAT "->,>>>,>>9.99" INITIAL "0" DECIMALS 2
   FIELD Qty AS INTEGER LABEL "Qty" FORMAT "->>>>9" INITIAL "0"
   FIELD Discount AS INTEGER LABEL "Discount" FORMAT ">>9%" INITIAL "0"
   FIELD ExtendedPrice AS DECIMAL LABEL "Extended Price" FORMAT "->>>,>>9.99" INITIAL "0" DECIMALS 2
   FIELD OrderLineStatus AS CHARACTER LABEL "Order Line Status" FORMAT "x(20)" INITIAL "Ordered"
        VIEW-AS COMBO-BOX
        LIST-ITEMS "Ordered","Back Ordered","Shipped"
    INDEX itemnum
        Itemnum
    INDEX orderline IS PRIMARY UNIQUE 
        Ordernum
        Linenum
    INDEX OrderLineStatus
        OrderLineStatus.


